import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class armstrade extends PApplet {

// The locatons array
Country[] countries;
Splines splines;
Segments segments;
Mouse mouse;
int NUM;
int ac = -1;
boolean debug = false;
boolean updateBubbles = true, globAniEnd = false, aPhaseOne = false,aPhaseTwo = true;

String[] topEx = { "All Countries", "USA", "USSR", "UK", "France", "Russia", "Germany", "China", "Czechoslovakia", "Italy"};
PFont font, bfont;
PShape back,legende;
PGraphics b;

float orgsize = 1920;
float thissize = 1000;
float sFac; //size factor
float bbubsize;
float space, bubsize;

public void setup() {
  noCursor();
  size(round(thissize), round(thissize));
  sFac = orgsize / thissize;
  println(sFac);  
  space = 30/sFac;
  bubsize = sFac*12;
  smooth();
  font = loadFont("Calibri-48.vlw");
  bfont = loadFont("Calibri-Bold-48.vlw");
  back = loadShape("azimuthal.svg");
  legende = loadShape("legende.svg");
  colorMode(HSB, 360, 100, 100,100);
  bbubsize = 35/sFac;
  
  // create background image
  b = createGraphics(width, height, JAVA2D);  
  b.beginDraw();
  b.smooth();
  b.shape(back, 0, 0, width, height);
  b.shape(legende, 0, 0, width, height);
  b.fill(100);
  b.textAlign(LEFT);
  b.textFont(font, 12); 
  b.pushMatrix();
  b.translate(width-220/sFac, 20/sFac+14);
  b.text("0  " + topEx[0], 0, 0);
  for(int i = 1; i < topEx.length;i++){
    b.text(i + "  " + topEx[i], 0, 8+i*14);
  }
  b.popMatrix();
  b.endDraw();
  
  //location xml
  XMLElement xml = new XMLElement(this, "data/location.xml");
  XMLElement[] nations = xml.getChildren();

  // create gigantic countries object array
  NUM = nations.length;
  countries = new Country[NUM];
  for (int i = 0; i < NUM; i++) {
    float lat = nations[i].getFloatAttribute("lat");
    float lng = nations[i].getFloatAttribute("lng");    
    
    String name = nations[i].getContent().replace("u.", "&");
    String code = nations[i].getStringAttribute("code");
    String continent = nations[i].getStringAttribute("continent");
    
    String ex = nations[i].getStringAttribute("export");
    boolean export = PApplet.parseBoolean(ex);
    String im = nations[i].getStringAttribute("import");
    boolean imp = PApplet.parseBoolean(im);
    
    countries[i] = new Country(lat, lng, name,code,continent,export,imp);
  }
  splines = new Splines();
  segments = new Segments();
  mouse = new Mouse();
  for (int i = 0; i < NUM; i++) {
    countries[i].setAllMode();
  }
}

public void draw() {
  background(20);
  fill(50);
  noStroke();
  ellipse(width/2, height/2, width, height);
  imageMode(CORNER);
  image(b, 0, 0, width, height); 

  textAlign(LEFT);
  textFont(font, 12); 
  pushMatrix();
  translate(20/sFac, 20/sFac+14);
  fill(100);
  text("showing", 0, 0);
  fill(200);
  if(ac != -1)
    text(countries[ac].name, 60, 0);
  else
    text(topEx[0], 60, 0);
  fill(100);
  if(mouse.select != -1)
    text("> " + countries[mouse.select].name, 160, 0);
  else
    text("> " + topEx[0], 160, 0);
  popMatrix();
  
  if(!updateBubbles) {
    if(!splines.current)
      splines.layoutSplines();  
    splines.drawSplines();
    if(ac != -1){    
      if(!segments.current)
        segments.layoutSegments();  
      segments.drawSegments();
    }
  }  
  mouse.draw();
  
  //update Balls
  if(updateBubbles) {
    updateBubbles = false;
    for(int i = 0; i<NUM; i++){
      countries[i].updatePosition();
      if(countries[i].moving)
        updateBubbles = countries[i].moving;
    }   
  }
  
  globAniEnd = true;
  for(int i = 0; i<NUM; i++){
    if(aPhaseOne && globAniEnd) // if first phase of animation == true && no bubble endet first phase of animation
      globAniEnd = countries[i].aniEnd(); // if true all bubbles endet first phase of animation
    if(aPhaseTwo && globAniEnd) 
      globAniEnd = countries[i].aniEnd(); 
    countries[i].update();
  }
  //println(aPhaseOne + " " + globAniEnd);

  if(aPhaseTwo && globAniEnd)
     aPhaseTwo = false;

  if(aPhaseOne && globAniEnd) {
    aPhaseOne = false;
    aPhaseTwo = true;
    for(int i = 0; i<NUM; i++){
      if(ac == -1)
        countries[i].setAllMode();
      else
       countries[i].setCountryMode(); 
    } 
  }
  stroke(0);
  fill(360);
  ellipse(mouseX,mouseY,5,5);
}//Ende void draw

public void mousePressed() {
  ac = mouse.select;
  updateBubbles = true;
  aPhaseOne = true;
  for(int i = 0; i<NUM; i++){
    if(ac != -1)
      countries[i].setAnimationMode(ac);  
    else
      countries[i].setAllMode();   
  }
}
public void keyPressed() {
  if(key == '1')
    ac = getLoc("USA");
  else if(key == '2')
    ac = getLoc("USSR");
  else if(key == '3')
    ac = getLoc("UK");
  else if(key == '4')
    ac = getLoc("France");
  else if(key == '5')
    ac = getLoc("Russia");
  else if(key == '6')
    ac = getLoc("Germany (FRG)");
  else if(key == '7')
    ac = getLoc("China");
  else if(key == '8')
    ac = getLoc("Czechoslovakia");
  else if(key == '9')
    ac = getLoc("Italy");
    
  if(key == '1' || key == '2' || key == '3' || key == '4' || key == '5' || key == '6' || key == '7' || key == '8' || key == '9') {
    updateBubbles = true;
    aPhaseOne = true;
    for(int i = 0; i<NUM; i++)
      countries[i].setAnimationMode(ac);  
  }
  if(key == '0'){
    updateBubbles = true;
    aPhaseOne = true;
    ac = -1;
    for(int i = 0; i<NUM; i++)
      countries[i].setAllMode();  
  }  
  if(key == 'd') {
    if(debug){debug = false;
    }else{debug = true;}
  }else if(key == 's'){
    updateBubbles = false;
    for(int i = 0; i<NUM; i++)
      countries[i].moving = false;
  }
}

// get Position of a Country in the locations Array  
public int getLoc(String name) {
  int count = -1;
  for (int i = 0; i < countries.length; i++) {
    if (name.equals(countries[i].name))
      count = i;
  } 
  return count;
}
public PVector getCol(String cont) {
  PVector c = new PVector(0,90);
  if (cont.equals("North America")){
    c.x = 0;c.y = 80;
  }else if (cont.equals("South America")){ 
    c.x = 50;
  }else if (cont.equals("Europe")){ 
    c.x = 100;
  }else if (cont.equals("Africa")){
    c.x = 150;
  }else if (cont.equals("Asia")){ 
    c.x = 200;
  }else if (cont.equals("Oceania")){  
    c.x = 250;c.y = 70;
  }else{ 
    c.x = 300;
  }
  return c;
}
  public float ease(float org, float temp, float tol, float speed) {  
    float dif = org - temp;
    if (abs(dif) < tol)
      temp = org;
    else temp += dif/speed;
    return temp;  
  }
class Country {

  int[] years;
  Trade[] exports;
  Trade[] imports;

  PVector cord, pos; // coordinate,actual position
  String name, code, cont;
  float exD,exDtemp, imD, imDtemp;
  
  int et;
  float tradet; // totaldata 
  int ex, im;
  
  float tempd, r, deg, tempdeg, sec, tempsec; // durchmesser
  float gRad; // global radiant zentrale ausrichtung
  float bbub, bbubtemp; // black label bubble
  float labelo = 0; // labelopacity
  boolean moving, uptodate;

  // Creates new Location.
  Country(float latitude, float longetude, String name, String code, String continent, boolean export,boolean impor) {
    this.name = name;
    this.code = code;
    this.cont = continent;
    this.imD = 0;
    this.exD = 0;
    this.imDtemp = 0;
    this.exDtemp = 0;
    
    this.et = 0;
    this.tradet = 0;
    this.im = -1;
    this.ex = -1;

    this.moving = true;
    this.uptodate = false;

    float lat = latitude / 180 * PI;
    float lng = longetude / 180 * PI;

    float lat0 = 89.99f* PI /180;
    float lng0 = 1 * PI /180;   
    float z = acos(sin(lat0)*sin(lat) + cos(lat)*cos(lat0)*cos(lng));
    float rho = width/5.4f *z; 
    float x = rho* (cos(lat)*sin(lng))/sin(z)+width/2;
    float y = rho* (cos(lat0)*sin(lat)- sin(lat0)*cos(lat)*cos(lng))/sin(z) * (-1) + height/2;   

    this.cord = new PVector(x, y);
    this.pos = new PVector(x, y);  

    PVector winkel = PVector.sub(this.pos, new PVector(width/2, height/2));
    this.gRad = -1*atan2(-1*winkel.y, winkel.x)-PI/2;   
    this.r = 0;
    this.tempd = 0;
    this.deg = 0; 
    this.tempdeg = this.gRad * (-1); 
    this.sec = 0; 
    this.tempsec = radians(180); 
    this.bbub = 0; 
    this.bbubtemp = 0; 

    int exlength = 0; 
    int imlength = 0; 

    //------------------------------------    Export    ---------------------------------------------------//  
    if(export){  
      String exlines[] = loadStrings("TIV/Export/" + this.name.replace("/", "_") + ".csv");
      if (exlines != null) {
        String total = exlines[exlines.length-1];
        exlines = subset(exlines, 0, exlines.length-2);
        exlines[exlines.length-1] = total;
        this.exports = new Trade[exlines.length-11];
        for (int i = 0; i < exlines.length-11; i++) {
          String[] list = split(exlines[i+11], ',');
          String recipient = list[1];
          //println(recipient);
          years = new int[list.length-2];
          for (int j = 2; j < list.length; j++) {
            if (list[j].length() > 0) {
              years[j-2] = Integer.parseInt(list[j]);
            }
            else {
              years[j-2] = 0;
            }
          }
          this.exports[i] = new Trade(years, recipient);
        }
        exlength = this.exports[0].years.length; 
        this.tradet = this.et = this.exports[this.exports.length-1].years[61];
      }
    }

    //------------------------------------    import    ---------------------------------------------------//
    if(impor){  
      String imlines[] = loadStrings("TIV/Import/" + this.name.replace("/", "_") + ".csv");
      if (imlines != null) {
        String total = imlines[imlines.length-1];
        imlines = subset(imlines, 0, imlines.length-2);
        imlines[imlines.length-1] = total;
        this.imports = new Trade[imlines.length-11];
        for (int i = 0; i < imlines.length-11; i++) {
          String[] list = split(imlines[i+11], ',');
          String recipient = list[1];
          //println(recipient);
          years = new int[list.length-2];
          for (int j = 2; j < list.length; j++) {
            if (list[j].length() > 0) {
              years[j-2] = Integer.parseInt(list[j]);
            }
            else {
              years[j-2] = 0;
            }
          }
          this.imports[i] = new Trade(years, recipient);
        } 
        imlength = this.imports[0].years.length; 
        this.tradet += this.imports[this.imports.length-1].years[61];
      }
    }
  }
  
    //------------------------------------    set Modes    ---------------------------------------------------//
  
  public void setAllMode() { // set Data for All Mode
    splines.current = false;
    this.moving = true;
    this.bbub = 0;
    this.sec = radians(360/this.tradet * this.et);
    this.r = sqrt(this.tradet/PI) / bubsize; // total == fl\u00e4che -> radius / fensterFactor 
    this.exD = this.r*2; 
    this.imD = this.r*2;     
    this.deg = 0;
    if (this.imports != null) {
      PVector impvec = new PVector(0, 0);
      for (int i=0; i<this.imports.length-1; i++) {
        int id = getLoc(this.imports[i].name); 
        if (id != -1) {
          if (impvec.mag() != 0) {
            PVector idvec = new PVector(countries[id].pos.x, countries[id].pos.y);
            idvec.sub(this.pos);
            this.deg = PVector.angleBetween(impvec, idvec);
          }
          impvec.add(countries[id].pos);
          impvec.sub(this.pos);
        }
      }
    }    
  }  
  
  public void setCountryMode() { // set Data for Country Mode
    this.ex = countries[ac].getTrade(this.name,countries[ac].exports);
    this.im = countries[ac].getTrade(this.name,countries[ac].imports);
    
    if(this.r > bbubsize/2){ 
      this.r = bbubsize/2; 
      this.exD = bbubsize; 
      this.imD = bbubsize;
    }
  }  
  
  public void setAnimationMode(int active) {
    splines.current = false;
    segments.current = false;
    this.moving = true;
    this.ex = countries[active].getTrade(this.name,countries[active].exports);
    this.im = countries[active].getTrade(this.name,countries[active].imports); 
    
    if (ex != -1 || im != -1 || countries[active].name.equals(this.name)) {  
      this.sec = radians(180);
      this.deg = this.gRad * (-1);
      this.bbub = bbubsize;
      if(ex != -1)
        this.imD = sqrt(countries[active].exports[ex].max/PI) * 2 / sFac + bbubsize; 
      else if(countries[active].name.equals(this.name) && this.exports != null)
        this.exD = sqrt(this.exports[this.exports.length-1].max/PI) * 2 / sFac + bbubsize; 
      if(im != -1)
        this.exD = sqrt(countries[active].imports[im].max/PI) * 2 / sFac + bbubsize; 
      else if(countries[active].name.equals(this.name) && this.imports != null)
        this.imD = sqrt(this.imports[this.imports.length-1].max/PI) *2 / sFac + bbubsize; 
      if(this.exD > this.imD)
        this.r = this.exD/2; 
      else 
        this.r = this.imD/2; 
    }else {
      this.r = 0; 
      this.exD = 0; 
      this.imD = 0;
      this.bbub = 0;
    }     
  }
   
    //------------------------------------    Collision test    ---------------------------------------------------//
    
  public void updatePosition() {
    PVector[] colisionPos = new PVector[0];
    float[] colisionDist = new float[0];
    float[] colisionAbsDist = new float[0];
    float maxDist = 0;

    PVector tocord = PVector.sub(this.pos, this.cord);
    float tocordl = tocord.mag();     
    float cordDist = dist(this.pos.x, this.pos.y, this.cord.x, this.cord.y);
    
    //println(colisionPos);
    //check for colision -> add to colisiontvector
    for (int i = 0; i < NUM; i++) { 
      if (!countries[i].name.equals(this.name)) {
        float distance = dist(this.pos.x, this.pos.y, countries[i].pos.x, countries[i].pos.y);
        float neededSpace = countries[i].tempd/2 + this.tempd/2 + space; //radius countrie(i)fl\u00e4che -> radius + this radius + space

        if (distance < neededSpace) {
          colisionPos = (PVector[]) append(colisionPos, countries[i].pos);
          colisionDist = (float[]) append(colisionDist, neededSpace-distance);
          colisionAbsDist = (float[]) append(colisionAbsDist, distance);
        }
      }
    }

    PVector gesamtweg = new PVector(0, 0);
    PVector[] ausweichweg = new PVector[colisionPos.length];

    //Berechne Ausweichwege f\u00fcr einzelne Konflikte
    for (int i = 0; i < ausweichweg.length; i++) {
      PVector ausweichRichtung = PVector.sub(this.pos, colisionPos[i]);
      ausweichRichtung.normalize();
      ausweichRichtung.mult(colisionDist[i]);
      if(colisionAbsDist[i] < tocordl + colisionDist[i])
        cordDist -= colisionDist[i];
      //if(colisionDist[i] > maxDist)maxDist = colisionDist[i];
      //ausweichweg[i] = PVector.sub(ausweichRichtung, PVector.sub(this.pos, colisionPos[i]));
      //gesamtweg.add(PVector.sub(ausweichRichtung, PVector.sub(this.pos, colisionPos[i])));
      gesamtweg.add(ausweichRichtung);
    }
    
    tocord.mag();
    tocord.add(this.pos);
    PVector movetocord = PVector.sub(this.pos,tocord);
    movetocord.normalize();
    movetocord.mult(cordDist);
    gesamtweg.add(movetocord);

    //Korrektur um innerhalb des Kreisausschnitts zu bleiben
    PVector mittelpunkt = new PVector(width/2, height/2);
    PVector neuPos = PVector.add(this.pos, gesamtweg);
    float maxEntfernung = width/2 - r - space - 60/sFac;
    PVector korrekturRichtung = PVector.sub(mittelpunkt, neuPos);
    float entfernung = korrekturRichtung.mag();
    if (entfernung > maxEntfernung) {
      korrekturRichtung.normalize();
      korrekturRichtung.mult(entfernung-maxEntfernung);      
      gesamtweg.add(korrekturRichtung);
    }

    PVector winkel = PVector.sub(this.pos, new PVector(width/2, height/2));
    this.gRad = -1*atan2(-1*winkel.y, winkel.x)-PI/2; 
    
    gesamtweg.div(10);

    if (gesamtweg.mag() > 0.2f) 
      this.pos.add(gesamtweg);
    else this.moving = false;
    
    //println(this.moving);
  }
  
  public boolean aniEnd(){
    boolean end;  
    float d = this.r*2;
    if(this.exDtemp == this.exD && this.imDtemp == this.imD && this.tempd == d && this.tempdeg == this.deg && this.tempsec == this.sec && this.bbubtemp == this.bbub && !this.moving)
      end = true;
    else end = false;
    
    return end;
  }

  //------------------------------------    draw    ---------------------------------------------------//
  public void update() {  
    
    PVector c = getCol(this.cont);

    float d = this.r*2;
    if(this.tempd != d)
      this.tempd = ease(d,this.tempd,0.1f,10);
    if(this.exDtemp != this.exD)
      this.exDtemp = ease(this.exD,this.exDtemp,0.1f,10);
    if(this.imDtemp != this.imD)
      this.imDtemp = ease(this.imD,this.imDtemp,0.1f,10);
    if(this.tempdeg != this.deg)  
      this.tempdeg = ease(this.deg,this.tempdeg,radians(1),10);   
    if(this.tempsec != this.sec)
      this.tempsec = ease(this.sec,this.tempsec,radians(1),10);
    if(this.bbubtemp != this.bbub)
      this.bbubtemp = ease(this.bbub,this.bbubtemp,0.1f,10);
      
      
    pushMatrix();
    translate(this.pos.x, this.pos.y);
    rotate(this.gRad);

    if (this.tempd > 0 && ac == -1 || aPhaseOne || aPhaseTwo) {

      //draw ball
      float view = this.gRad + this.tempdeg-this.tempsec/2;          
      noStroke();
      fill(c.x, c.y-10, 100);
      arc(0, 0, this.exDtemp, this.exDtemp, view, view+this.tempsec);
      fill(c.x, c.y, 70);
      arc(0, 0, this.imDtemp, this.imDtemp, view+this.tempsec, radians(360)+view);
    }
    //------------ country mode
    //if(this.ex != -1 && this.im != -1 || countries[ac].name.equals(this.name)){
    
    //}
    //if(exp ||  imp || acname){
    float bbubDif = this.bbub - this.bbubtemp;
    if (bbubDif > 0 || this.bbubtemp > 0) {
      fill(0);
      noStroke();
      ellipse(0, 0, this.bbubtemp, this.bbubtemp);
    }  
    //if (ac != -1 ||  ac == -1 aPhaseOne) {
      int visible;
      if ((ac != -1 &! aPhaseOne || ac == -1 &! aPhaseTwo) && this.bbub == bbubsize)visible = 100;
      else visible = 0;

      float labelDif = visible - labelo;
      if (abs(labelDif) < 0.1f)
        labelo = visible;
      else labelo += labelDif/10;

      fill(300, labelo);
      textAlign(CENTER, CENTER);
      textFont(bfont, 12/sFac); 
      text(this.code, 0, 0);
    //}
    // }

    popMatrix();   
      
    if (debug) {
      stroke(200);
      line(this.cord.x, this.cord.y, this.pos.x, this.pos.y);
    }
  }  

  //------------------------------------   get location inArray    ---------------------------------------------------//

// get Position of a Country in the Trade Array  
public int getTrade(String name, Trade[] t) {
  int count = -1;
  if (t != null) {
    for (int i = 0; i < t.length; i++) {
      if (name.equals(t[i].name))
        count = i;
    }
  } 
  return count;
}  
}

class Mouse {

  PVector cord, pos; // coordinate,actual position
  float d,dTemp;
  int select;
  
  Mouse() {
    this.cord = new PVector(0, 0);
    this.pos = new PVector(0, 0);
    this.d = 0;
    this.dTemp = 0;
    this.select = -1;
  }
  public void draw(){
    float sDist = 0;
    int count = 0;
    if(over(mouseX,mouseY)){
      for (int i = 0; i < NUM; i++) {
        if(ac == -1 || countries[i].bbub == bbubsize){
          float thisDist = dist(countries[i].pos.x,countries[i].pos.y,mouseX,mouseY);
          if(sDist == 0 || sDist > thisDist){
            sDist = thisDist;
            count = i;
          }
        }
      }
      this.select = count;
      this.cord.set(countries[count].pos);
      this.d = (countries[count].r *2) + 10/sFac;
    }else{
      this.select = -1;
      this.cord.set(mouseX,mouseY,0);
      this.d = 0;
    }
    
    this.pos.x = ease(this.cord.x,this.pos.x,1,3);
    this.pos.y = ease(this.cord.y,this.pos.y,1,3);
    this.dTemp = ease(this.d,this.dTemp,1,3);
    if(over(this.pos.x,this.pos.y)){      
      noStroke();
      fill(360);
      ellipse(this.pos.x,this.pos.y,this.dTemp,this.dTemp);
    }
  }
 public boolean over(float x, float y) {
    float disX = width/2 - x;
    float disY = height/2 - y;
    if (sqrt(sq(disX) + sq(disY)) < width/2 ) {
      return true;
    } else {
      return false;
    }
  }
}
class Segments {
  PGraphics s;
  boolean current;

  Segments() {
    this.s = createGraphics(width, height, JAVA2D);  
    this.current = false;
  }

  public void layoutSegments() {  
    this.s.beginDraw();
    this.s.background(0, 0);
    this.s.smooth();  
    this.s.colorMode(HSB, 360, 100, 100);    
    this.s.noStroke();

    for(int i = 0; i<NUM; i++){
      String name = countries[i].name;
      int ex = countries[ac].getTrade(name, countries[ac].exports);
      int im = countries[ac].getTrade(name, countries[ac].imports); 

      boolean exp = false, imp = false, acname = false;
      if (ex != -1)
        exp=true;
      if (im != -1)
        imp=true;
      
      acname = countries[ac].name.equals(countries[i].name);

      this.s.pushMatrix();
      this.s.translate(countries[i].pos.x, countries[i].pos.y);  
      this.s.rotate(countries[i].gRad);
    
      PVector c = getCol(countries[i].cont);   
      
      if(imp || acname){
        int[] exports = getExport(im,name);
        //float max = max(exports);
        float degplus = 180.0f/(exports.length-1);
        for(int j=0; j<exports.length-1; j++){
          if(exports[j] > 0){
            float deg =  PI / 2 - radians(j*degplus);
            float r = sqrt(exports[j]/PI)*2/sFac+bbubsize;
            
            //int l = round(exports[j]/max*40)+60;
            int l = 0;
            if ((j & 1) == 0)
              l = 100;
            else
              l = 70;
               
            this.s.fill(c.x, c.y-10, l);
            this.s.arc(0,0,r,r,deg, deg + radians(degplus));
          }
        }  
      }
      if(exp || acname){   
        int[] imports = getImport(ex, name);
        //float max = max(imports);
        float degplus = 180.0f/(imports.length-1);
        for(int j=0; j<imports.length-1; j++){
          if(imports[j] > 0){       
            float deg = PI / 2 + radians((j+1)*degplus);        
            float r = (sqrt(imports[j]/PI)*2)/sFac+bbubsize;
                      
            //int l = round(imports[j]/max*50)+50;
            int l = 0;
            if ((j & 1) == 0)
              l = 70;
            else
              l = 40;

            this.s.fill(c.x, c.y,l);
            this.s.arc(0,0,r,r,deg, deg + radians(degplus));
          }
        } 
      }
            
      this.s.popMatrix(); 
    }
    this.s.endDraw(); 
    this.current = true;
  }
  
  public int[] getExport(int im, String name) { 
    if (im != -1) 
      return countries[ac].imports[im].years;
    else if (countries[ac].name.equals(name) && countries[ac].exports != null) 
      return countries[ac].exports[countries[ac].exports.length-1].years; 
    else
      return new int[0];  
  }
  public int[] getImport( int ex, String name) { 
    if (ex != -1 )
      return countries[ac].exports[ex].years;
    else if (countries[ac].name.equals(name) && countries[ac].imports != null)
      return countries[ac].imports[countries[ac].imports.length-1].years;  
    else
      return new int[0];    
  } 
  public int getMax(String trade, int j, boolean name) { 
    if (!name && trade.equals("ex")) 
      return countries[ac].imports[j].max;
    else if(trade.equals("ex"))
      return countries[ac].exports[countries[ac].exports.length-1].max; 
    else if(!name && trade.equals("im"))
      return countries[ac].exports[j].max; 
    else if(trade.equals("im"))
      return countries[ac].imports[countries[ac].imports.length-1].max; 
    else
      return 0;
  }  
  public void drawSegments(){      
    if(this.s != null){
      image(this.s, 0, 0, width, height); 
    }/*else if(this.exports != null && this.imports != null){
      
    }*/
  }
}
class Splines {
  PGraphics s;
  boolean current;

  Splines() {
    this.s = createGraphics(width, height, JAVA2D);  
    this.current = false;
  }

  public void layoutSplines(){  
    this.s.beginDraw();
    this.s.background(0, 0);
    this.s.smooth();  
    this.s.colorMode(HSB, 360, 100, 100);
    //this.s.curveTightness(-2); 
    if(ac == -1){  
      for(int i = 0; i<NUM; i++){
        PVector c = getCol(countries[i].cont);    
        //draw lines
        if(countries[i].exports != null){
          for(int j=0; j<countries[i].exports.length-1; j++){
            int id = getLoc(countries[i].exports[j].name);//(countries[i].exports[j].name);      
            if(id != -1){
              int trade = countries[i].exports[j].years[countries[i].exports[j].years.length-1];
              drawLine(this.s,trade,countries[i],countries[id],c,j, countries[i].exports.length, countries[id].imports.length);
            }
          }
        }
      }
    }else{
      if(countries[ac].exports != null){
        PVector c = getCol(countries[ac].cont);
        for(int j=0; j<countries[ac].exports.length-1; j++){
          int id = getLoc(countries[ac].exports[j].name);//(countries[i].exports[j].name);      
          if(id != -1){
            int trade = countries[ac].exports[j].years[countries[ac].exports[j].years.length-1];
            drawLine(this.s,trade,countries[ac],countries[id],c,j, countries[ac].exports.length, countries[id].imports.length);           
          }
        }
      }
      if(countries[ac].imports != null){
        for(int j=0; j<countries[ac].imports.length-1; j++){
          int id = getLoc(countries[ac].imports[j].name);//(countries[i].exports[j].name);     
          if(id != -1){
            PVector c = getCol(countries[id].cont); 
            int trade = countries[ac].imports[j].years[countries[ac].imports[j].years.length-1];
            drawLine(this.s,trade,countries[id],countries[ac],c,j, countries[ac].imports.length, countries[id].exports.length);                               
          }
        }
      }
    }
    this.s.endDraw(); 
    this.current = true;
  }

  public void drawLine(PGraphics p,int trade, Country fromC, Country toC,PVector c,int j, int fromL,int toL){      
    p.noFill();
    p.strokeWeight(trade/(sFac*10000));
    p.stroke(c.x, c.y-10, 60);//trade/(sFac*1000)
    //this.expSegments[i].y = countries[ac].imports[id].years[i];
    /*p.beginShape();
    p.curveVertex(fromC.pos.x,fromC.pos.y);
    p.curveVertex(fromC.pos.x,fromC.pos.y);*/
    //p.curveVertex(fromC.pos.x,fromC.pos.y);
    /*int points = round(dist(countries[i].pos.x,  countries[i].pos.y,countries[id].pos.x,  countries[id].pos.y)/(sFac*10));
    for(int k = 0; k<=points; k++){     
      PVector node = new PVector(countries[i].pos.x,countries[i].pos.y);                
      node.x += (countries[id].pos.x - countries[i].pos.x)/points*k;
      node.y += (countries[id].pos.y - countries[i].pos.y)/points*k;
      this.s.curveVertex(node.x,node.y);
    }*/  
    float r = 0;
    float view = fromC.gRad + (fromC.gRad - fromC.deg) - (2*PI-fromC.sec)/2;          
    //arc(0, 0, this.exDtemp, this.exDtemp, view, view+this.tempsec);
    //arc(0, 0, this.imDtemp, this.imDtemp, view+this.tempsec, radians(360)+view);
    
    if(ac == -1)
      r = fromC.r*2;
    if(r < bbubsize*2 || ac != -1)
      r = bbubsize * 2; 
      
    PVector fromNode = new PVector(cos(view) * r,sin(view) * r); 
    fromNode.add(fromC.pos);    
    /*PVector fromNode = new PVector(fromC.pos.x,fromC.pos.y);    
    fromNode.sub(toC.pos);
    fromNode.normalize();
    fromNode.mult(fromC.r/2*(-1)); //radius: bbubsze || .r
    fromNode.add(fromC.pos);*/
    //p.curveVertex(fromNode.x,fromNode.y);
    
    
    
    
    view = toC.gRad + (toC.gRad - toC.deg) + toC.sec/2;
    //println(degrees(view) + " " + degrees(toC.gRad)+ " " + degrees(toC.deg)+ " " + degrees(toC.sec/2));  
    if(ac == -1)
      r = toC.r*2;
    if(r < bbubsize*2 || ac != -1)
      r = bbubsize * 2; 

    PVector toNode = new PVector(cos(view) * r,sin(view) * r); 
    toNode.add(toC.pos);  
    /*
    PVector toNode = new PVector(fromC.pos.x,fromC.pos.y);    
    toNode.sub(toC.pos);
    toNode.normalize();
    toNode.mult(toC.r/2);
    toNode.add(toC.pos);*/
    /*p.curveVertex(toNode.x,toNode.y);

    p.curveVertex(toC.pos.x,  toC.pos.y);
    p.curveVertex(toC.pos.x,  toC.pos.y);
    p.endShape();*/
    
    
    p.bezier(fromC.pos.x,fromC.pos.y, fromNode.x,fromNode.y, toNode.x,toNode.y, toC.pos.x,  toC.pos.y);
    
    //p.fill(360);
    //p.ellipse(toNode.x,toNode.y,3,3);
  }
  
  public void drawSplines(){      
    if(this.s != null){
      image(this.s, 0, 0, width, height); 
    }/*else if(this.exports != null && this.imports != null){
      
    }*/
  }
}
class Trade {

  int[] years;
  String name;
  int max;
  
  Trade(int[] y, String n) {
    this.years = new int[y.length];
    this.max = 0;
    for (int i = 0; i < y.length; i++) {
      this.years[i] = new Integer(y[i]);
      if(this.max < y[i] && i < y.length-1){this.max = y[i];}
    }
    this.name = new String(n);
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "armstrade" });
  }
}
